      subroutine jacobi (n,m,dx,dy,alpha,omega,u,f,tol,maxit)

      implicit none 
      integer n,m,maxit
      double precision dx,dy,f(n,m),u(n,m),alpha, tol,omega

      integer i,j,k,k_local 
      double precision error,resid,rsum,ax,ay,b
      double precision error_local, uold(n,m)

      real ta,tb,tc,td,te,ta1,ta2,tb1,tb2,tc1,tc2,td1,td2
      real te1,te2

      ax = 1.0/(dx*dx) ! X-direction coef 
      ay = 1.0/(dy*dy) ! Y-direction coef
      b  = -2.0/(dx*dx)-2.0/(dy*dy) - alpha ! Central coeff  

      error = 10.0 * tol 

      k = 1

      do while (k.le.maxit .and. error.gt. tol) 
         error = 0.0    
         do j=1,m
            do i=1,n
               uold(i,j) = u(i,j) 
            enddo
         enddo

         do j = 2,m-1
            do i = 2,n-1 
               resid = (ax*(uold(i-1,j) + uold(i+1,j)) &
     &                + ay*(uold(i,j-1) + uold(i,j+1)) &
     &                 + b * uold(i,j) - f(i,j))/b
               u(i,j) = uold(i,j) - omega * resid
               error = error + resid*resid 
            end do
         enddo

         k = k + 1
         error = sqrt(error)/dble(n*m)

      enddo                     ! End iteration loop
      
      print *, 'Total Number of Iterations ', k 
      print *, 'Residual                   ', error 
      
      maxit = k - 1

      return 
      end 
