      subroutine jacobi (n,m,dx,dy,alpha,omega,u,f,tol,maxit)

      implicit none 
      integer n,m,maxit
      double precision dx,dy,f(n,m),u(n,m),alpha, tol,omega

      integer i,j,k,k_local, u0
      double precision error,resid,rsum,ax,ay,b
      double precision error_local, uh(n,m,0:1)

      real ta,tb,tc,td,te,ta1,ta2,tb1,tb2,tc1,tc2,td1,td2
      real te1,te2

      ax = 1.0/(dx*dx) ! X-direction coef 
      ay = 1.0/(dy*dy) ! Y-direction coef
      b  = -2.0/(dx*dx)-2.0/(dy*dy) - alpha ! Central coeff  

      do j=1,m
         do i=1,n
            uh(i,j,0) = u(i,j) 
         enddo
      enddo

      do j=1,m, m-1
         do i=1,n
            uh(i,j,1) = u(i,j) 
         enddo
      enddo
      do j=2,m-1
         do i=1,n,n-1
            uh(i,j,1) = u(i,j) 
         enddo
      enddo
      
      u0 = 0
      uh = 0
      error = 10.0 * tol 

      k = 1

      do while (k.le.maxit .and. error.gt. tol) 

         error = 0.0    

         do j = 2,m-1
            do i = 2,n-1 
               resid = (ax*(uh(i-1,j,u0) + uh(i+1,j,u0)) &
     &                + ay*(uh(i,j-1,u0) + uh(i,j+1,u0)) &
     &                 + b * uh(i,j,u0) - f(i,j))/b
               uh(i,j,1-u0) = uh(i,j,u0) - omega * resid
               error = error + resid*resid 
            end do
         enddo

         k = k + 1
         error = sqrt(error)/dble(n*m)
	 u0 = 1 - u0

      enddo                     ! End iteration loop
      
         do j = 1,m
            do i = 1,n
	       u(i,j) = uh(i,j,1-u0) 
            end do
         enddo
	 
      print *, 'Total Number of Iterations ', k 
      print *, 'Residual                   ', error 

      return 
      end 
